import 'package:flutter/material.dart';
import 'package:flutter_custom_form_component/widget/const.dart';

/// Mixin supports entire text field on plugin.
mixin FieldMixin {
  bool _valid = fieldValid;

  /// Container has infinity height and width, rounded border and horizontal padding.
  Widget container(final TextField textField) => Container(
      child: Padding(
          child: textField,
          padding: EdgeInsets.symmetric(horizontal: horizontalPadding)),
      decoration: decoration,
      height: double.infinity,
      width: double.infinity);

  BoxDecoration get decoration;

  double get horizontalPadding;

  TextStyle get style;

  set valid(final bool valid) => _valid = valid;

  bool get valid => _valid;
}
