import 'package:flutter/material.dart';
import 'package:flutter_custom_form_component/widget/const.dart';
import 'package:flutter_custom_form_component/widget/field/box_decorations.dart';
import 'package:flutter_custom_form_component/widget/field/text_styles.dart';
import 'package:flutter_custom_form_component/widget/field/widget.dart';

abstract class OneValueFieldWidget extends FieldWidget {
  late final dynamic _initialValue;
  late final Function(dynamic value)? _onChanged;

  OneValueFieldWidget(
      {final TextInputAction action = fieldAction,
      final BoxDecorations? decorations,
      final bool enabled = fieldEnabled,
      final String? hint,
      final double horizontalPadding = fieldHorizontalPadding,
      final dynamic initialValue,
      final Key? key,
      final Function(dynamic value)? onChanged,
      final TextStyles? styles})
      : super(
            action: action,
            decorations: decorations,
            enabled: enabled,
            hint: hint,
            horizontalPadding: horizontalPadding,
            key: key,
            styles: styles) {
    _initialValue = initialValue;
    _onChanged = onChanged;
  }

  dynamic get initialValue => _initialValue;

  Function(dynamic value)? get onChanged => _onChanged;
}
