import 'package:flutter/material.dart';
import 'package:flutter_custom_form_component/widget/const.dart';
import 'package:flutter_custom_form_component/widget/field/box_decorations.dart';
import 'package:flutter_custom_form_component/widget/field/text_styles.dart';

abstract class FieldWidget extends StatefulWidget {
  late final TextInputAction _action;
  late final BoxDecorations _decorations;
  late final bool _enabled;
  late final String? _hint;
  late final double _horizontalPadding;
  late final TextStyles _styles;

  FieldWidget(
      {final TextInputAction action = fieldAction,
      final BoxDecorations? decorations,
      final bool enabled = fieldEnabled,
      final String? hint,
      final double horizontalPadding = fieldHorizontalPadding,
      final Key? key,
      final TextStyles? styles})
      : super(key: key) {
    _action = action;
    _decorations = decorations ?? BoxDecorations();
    _enabled = enabled;
    _hint = hint;
    _horizontalPadding = horizontalPadding;
    _styles = styles ?? TextStyles();
  }

  TextInputAction get action => _action;

  BoxDecorations get decorations => _decorations;

  bool get enabled => _enabled;

  String? get hint => _hint;

  double get horizontalPadding => _horizontalPadding;

  TextStyles get styles => _styles;
}
